package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi.jx;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesOutPutStatistics;
import cn.estsh.i3plus.ext.mes.pojo.bean.MesWorkCenterExt;
import cn.estsh.i3plus.platform.common.tool.MathOperation;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrder;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.CollectionUtils;

import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author : wangjie
 * @CreateDate : 2022-02-15
 * @Modify:
 **/
@Slf4j
public class JxCenterWorkingBoardCommonService {

    public List<MesWorkOrder> getWorkOrderList2Sort(List<MesWorkOrder> workOrderList, List<MesOutPutStatistics> outPutStatisticsList, MesWorkCenterExt workCenterExtDb) {
        List<String> hasOutPutOrder = CollectionUtils.isEmpty(outPutStatisticsList) ? null : outPutStatisticsList.stream().filter(o -> null != o).map(MesOutPutStatistics::getWorkOrderNo).collect(Collectors.toList());
        return CollectionUtils.isEmpty(workOrderList) ? null :
                workOrderList.stream().filter(o -> (null != o && (
                        o.getStartTime().contains(workCenterExtDb.getWorkTime()) || (MathOperation.compareTo(o.getQty(), o.getCompleteQty()) != 0 || (!CollectionUtils.isEmpty(hasOutPutOrder) && hasOutPutOrder.contains(o.getOrderNo())))
                ))).sorted(Comparator.comparing(MesWorkOrder::getSeq)).collect(Collectors.toList());
    }

    public Double getOutPutStatisticsList2AmountQty(List<MesOutPutStatistics> outPutStatisticsList) {
        return CollectionUtils.isEmpty(outPutStatisticsList) ? new Double(0) : outPutStatisticsList.stream().filter(o -> null != o).mapToDouble(MesOutPutStatistics::getQty).sum();
    }

    public String getQtyStr(Double qty) { return qty.intValue() + "台"; }

}